Index: /pjproject/trunk/pjmedia/src/pjmedia/echo_common.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/echo_common.c	(revision 6128)
+++ /pjproject/trunk/pjmedia/src/pjmedia/echo_common.c	(revision 6129)
@@ -100,5 +100,5 @@
 static struct ec_operations speex_aec_op = 
 {
-    "AEC",
+    "Speex AEC",
     &speex_aec_create,
     &speex_aec_destroy,
Index: /pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c	(revision 6128)
+++ /pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c	(revision 6129)
@@ -36,8 +36,10 @@
 {
     SpeexEchoState	 *state;
-    SpeexPreprocessState *preprocess;
+    SpeexDecorrState 	 *decorr;
+    SpeexPreprocessState **preprocess;
 
     unsigned		  samples_per_frame;
-    unsigned		  prefetch;
+    unsigned		  channel_count;
+    unsigned		  spf_per_channel;
     unsigned		  options;
     pj_int16_t		 *tmp_frame;
@@ -58,5 +60,5 @@
 {
     speex_ec *echo;
-    int sampling_rate;
+    int i, sampling_rate;
 
     *p_echo = NULL;
@@ -65,9 +67,11 @@
     PJ_ASSERT_RETURN(echo != NULL, PJ_ENOMEM);
 
+    echo->channel_count = channel_count;
     echo->samples_per_frame = samples_per_frame;
+    echo->spf_per_channel = samples_per_frame / channel_count;
     echo->options = options;
 
-#if 0
-    echo->state = speex_echo_state_init_mc(echo->samples_per_frame,
+#if 1
+    echo->state = speex_echo_state_init_mc(echo->spf_per_channel,
 					   clock_rate * tail_ms / 1000,
 					   channel_count, channel_count);
@@ -80,7 +84,11 @@
     					clock_rate * tail_ms / 1000);
 #endif
-    if (echo->state == NULL) {
+    if (echo->state == NULL)
 	return PJ_ENOMEM;
-    }
+
+    echo->decorr = speex_decorrelate_new(clock_rate, channel_count,
+    					 echo->spf_per_channel);
+    if (echo->decorr == NULL)
+	return PJ_ENOMEM;
 
     /* Set sampling rate */
@@ -89,46 +97,48 @@
 		   &sampling_rate);
 
-    echo->preprocess = speex_preprocess_state_init(echo->samples_per_frame,
-						   clock_rate);
-    if (echo->preprocess == NULL) {
-	speex_echo_state_destroy(echo->state);
+    /* We need to create one state per channel processed. */
+    echo->preprocess = PJ_POOL_ZALLOC_T(pool, SpeexPreprocessState *);
+    for (i = 0; i < channel_count; i++) {
+	spx_int32_t enabled;
+
+    	echo->preprocess[i] = speex_preprocess_state_init(
+    				  echo->spf_per_channel, clock_rate);
+    	if (echo->preprocess[i] == NULL) {
+    	    speex_aec_destroy(echo);
+	    return PJ_ENOMEM;
+	}
+
+    	/* Enable/disable AGC & denoise */
+	enabled = PJMEDIA_SPEEX_AEC_USE_AGC;
+	speex_preprocess_ctl(echo->preprocess[i], SPEEX_PREPROCESS_SET_AGC,
+			     &enabled);
+
+	enabled = PJMEDIA_SPEEX_AEC_USE_DENOISE;
+	speex_preprocess_ctl(echo->preprocess[i],
+			     SPEEX_PREPROCESS_SET_DENOISE, &enabled);
+
+    	/* Currently, VAD and dereverb are set at default setting. */
+    	/*
+    	enabled = 1;
+    	speex_preprocess_ctl(echo->preprocess[i], SPEEX_PREPROCESS_SET_VAD,
+			     &enabled);
+    	speex_preprocess_ctl(echo->preprocess[i],
+    			     SPEEX_PREPROCESS_SET_DEREVERB,
+			     &enabled);
+	*/
+
+    	/* Control echo cancellation in the preprocessor */
+   	speex_preprocess_ctl(echo->preprocess[i],
+   			     SPEEX_PREPROCESS_SET_ECHO_STATE, echo->state);
+    }
+
+    /* Create temporary frame for echo cancellation */
+    echo->tmp_frame = (pj_int16_t*) pj_pool_zalloc(pool, sizeof(pj_int16_t) *
+    						   channel_count *
+    						   samples_per_frame);
+    if (!echo->tmp_frame) {
+    	speex_aec_destroy(echo);
 	return PJ_ENOMEM;
     }
-
-    /* Disable all preprocessing, we only want echo cancellation */
-#if 0
-    disabled = 0;
-    enabled = 1;
-    speex_preprocess_ctl(echo->preprocess, SPEEX_PREPROCESS_SET_DENOISE, 
-			 &enabled);
-    speex_preprocess_ctl(echo->preprocess, SPEEX_PREPROCESS_SET_AGC, 
-			 &disabled);
-    speex_preprocess_ctl(echo->preprocess, SPEEX_PREPROCESS_SET_VAD, 
-			 &disabled);
-    speex_preprocess_ctl(echo->preprocess, SPEEX_PREPROCESS_SET_DEREVERB, 
-			 &enabled);
-#endif
-
-    /* Enable/disable AGC & denoise */
-    {
-	spx_int32_t enabled;
-
-	enabled = PJMEDIA_SPEEX_AEC_USE_AGC;
-	speex_preprocess_ctl(echo->preprocess, SPEEX_PREPROCESS_SET_AGC, 
-			     &enabled);
-
-	enabled = PJMEDIA_SPEEX_AEC_USE_DENOISE;
-	speex_preprocess_ctl(echo->preprocess, SPEEX_PREPROCESS_SET_DENOISE, 
-			     &enabled);
-    }
-
-    /* Control echo cancellation in the preprocessor */
-   speex_preprocess_ctl(echo->preprocess, SPEEX_PREPROCESS_SET_ECHO_STATE, 
-			echo->state);
-
-
-    /* Create temporary frame for echo cancellation */
-    echo->tmp_frame = (pj_int16_t*) pj_pool_zalloc(pool, 2*samples_per_frame);
-    PJ_ASSERT_RETURN(echo->tmp_frame != NULL, PJ_ENOMEM);
 
     /* Done */
@@ -145,4 +155,5 @@
 {
     speex_ec *echo = (speex_ec*) state;
+    unsigned i;
 
     PJ_ASSERT_RETURN(echo && echo->state, PJ_EINVAL);
@@ -153,6 +164,16 @@
     }
 
+    if (echo->decorr) {
+	speex_decorrelate_destroy(echo->decorr);
+	echo->decorr = NULL;
+    }
+
     if (echo->preprocess) {
-	speex_preprocess_state_destroy(echo->preprocess);
+        for (i = 0; i < echo->channel_count; i++) {
+	    if (echo->preprocess[i]) {
+	    	speex_preprocess_state_destroy(echo->preprocess[i]);
+	    	echo->preprocess[i] = NULL;
+	    }
+	}
 	echo->preprocess = NULL;
     }
@@ -182,4 +203,5 @@
 {
     speex_ec *echo = (speex_ec*) state;
+    unsigned i;
 
     /* Sanity checks */
@@ -193,6 +215,25 @@
 
 
-    /* Preprocess output */
-    speex_preprocess_run(echo->preprocess, (spx_int16_t*)echo->tmp_frame);
+    /* Preprocess output per channel */
+    for (i = 0; i < echo->channel_count; i++) {
+    	spx_int16_t *buf = (spx_int16_t*)echo->tmp_frame;
+    	unsigned j;
+
+        /* De-interleave each channel. */
+        if (echo->channel_count > 1) {
+    	    for (j = 0; j < echo->spf_per_channel; j++) {
+    	        rec_frm[j] = echo->tmp_frame[j * echo->channel_count + i];
+    	    }
+    	    buf = (spx_int16_t*)rec_frm;
+    	}
+
+	speex_preprocess_run(echo->preprocess[i], buf);
+
+        if (echo->channel_count > 1) {
+    	    for (j = 0; j < echo->spf_per_channel; j++) {
+    	        echo->tmp_frame[j * echo->channel_count + i] = rec_frm[j];
+    	    }
+    	}
+    }
 
     /* Copy temporary buffer back to original rec_frm */
@@ -213,4 +254,13 @@
     /* Sanity checks */
     PJ_ASSERT_RETURN(echo && play_frm, PJ_EINVAL);
+
+    /* Channel decorrelation algorithm is useful for multi-channel echo
+     * cancellation only .
+     */
+    if (echo->channel_count > 1) {
+    	pjmedia_copy_samples(echo->tmp_frame, play_frm, echo->samples_per_frame);
+    	speex_decorrelate(echo->decorr, (spx_int16_t*)echo->tmp_frame,
+    		      	  (spx_int16_t*)play_frm, 100);
+    }
 
     speex_echo_playback(echo->state, (spx_int16_t*)play_frm);
@@ -228,4 +278,5 @@
 {
     speex_ec *echo = (speex_ec*) state;
+    unsigned i;
 
     /* Sanity checks */
@@ -235,11 +286,31 @@
 
     /* Cancel echo */
-    pjmedia_copy_samples(echo->tmp_frame, rec_frm, echo->samples_per_frame);
     speex_echo_capture(echo->state,
-		       (spx_int16_t*)echo->tmp_frame,
-		       (spx_int16_t*)rec_frm);
-
-    /* Apply preprocessing */
-    speex_preprocess_run(echo->preprocess, (spx_int16_t*)rec_frm);
+		       (spx_int16_t*)rec_frm,
+		       (spx_int16_t*)echo->tmp_frame);
+
+    /* Apply preprocessing per channel. */
+    for (i = 0; i < echo->channel_count; i++) {
+    	spx_int16_t *buf = (spx_int16_t*)echo->tmp_frame;
+    	unsigned j;
+
+        /* De-interleave each channel. */
+        if (echo->channel_count > 1) {
+    	    for (j = 0; j < echo->spf_per_channel; j++) {
+    	        rec_frm[j] = echo->tmp_frame[j * echo->channel_count + i];
+    	    }
+    	    buf = (spx_int16_t*)rec_frm;
+    	}
+
+	speex_preprocess_run(echo->preprocess[i], buf);
+
+        if (echo->channel_count > 1) {
+    	    for (j = 0; j < echo->spf_per_channel; j++) {
+    	        echo->tmp_frame[j * echo->channel_count + i] = rec_frm[j];
+    	    }
+    	}
+    }
+
+    pjmedia_copy_samples(rec_frm, echo->tmp_frame, echo->samples_per_frame);
 
     return PJ_SUCCESS;
Index: /pjproject/trunk/third_party/build/speex/Makefile
===================================================================
--- /pjproject/trunk/third_party/build/speex/Makefile	(revision 6128)
+++ /pjproject/trunk/third_party/build/speex/Makefile	(revision 6129)
@@ -40,5 +40,5 @@
 			quant_lsp.o resample.o sb_celp.o smallft.o \
 			speex.o speex_callbacks.o speex_header.o \
-			stereo.o vbr.o vq.o window.o
+			scal.o stereo.o vbr.o vq.o window.o
 
 export SPEEX_CFLAGS = -DHAVE_CONFIG_H $(_CFLAGS)
Index: /pjproject/trunk/third_party/speex/include/speex/speex_buffer.h
===================================================================
--- /pjproject/trunk/third_party/speex/include/speex/speex_buffer.h	(revision 6128)
+++ /pjproject/trunk/third_party/speex/include/speex/speex_buffer.h	(revision 6129)
@@ -35,5 +35,5 @@
 #define SPEEX_BUFFER_H
 
-#include "speex/speex_types.h"
+#include "speexdsp_types.h"
 
 #ifdef __cplusplus
Index: /pjproject/trunk/third_party/speex/include/speex/speex_echo.h
===================================================================
--- /pjproject/trunk/third_party/speex/include/speex/speex_echo.h	(revision 6128)
+++ /pjproject/trunk/third_party/speex/include/speex/speex_echo.h	(revision 6129)
@@ -38,5 +38,5 @@
  *  @{
  */
-#include "speex/speex_types.h"
+#include "speexdsp_types.h"
 
 #ifdef __cplusplus
Index: /pjproject/trunk/third_party/speex/include/speex/speex_jitter.h
===================================================================
--- /pjproject/trunk/third_party/speex/include/speex/speex_jitter.h	(revision 6128)
+++ /pjproject/trunk/third_party/speex/include/speex/speex_jitter.h	(revision 6129)
@@ -42,5 +42,5 @@
  */
 
-#include "speex/speex_types.h"
+#include "speexdsp_types.h"
 
 #ifdef __cplusplus
Index: /pjproject/trunk/third_party/speex/include/speex/speex_preprocess.h
===================================================================
--- /pjproject/trunk/third_party/speex/include/speex/speex_preprocess.h	(revision 6128)
+++ /pjproject/trunk/third_party/speex/include/speex/speex_preprocess.h	(revision 6129)
@@ -44,5 +44,5 @@
  */
 
-#include "speex/speex_types.h"
+#include "speexdsp_types.h"
 
 #ifdef __cplusplus
Index: /pjproject/trunk/third_party/speex/include/speex/speex_resampler.h
===================================================================
--- /pjproject/trunk/third_party/speex/include/speex/speex_resampler.h	(revision 6128)
+++ /pjproject/trunk/third_party/speex/include/speex/speex_resampler.h	(revision 6129)
@@ -83,7 +83,9 @@
 #define spx_uint32_t unsigned int
       
+#define speex_assert(cond)
+
 #else /* OUTSIDE_SPEEX */
 
-#include "speex/speex_types.h"
+#include "speexdsp_types.h"
 
 #endif /* OUTSIDE_SPEEX */
@@ -105,4 +107,5 @@
    RESAMPLER_ERR_INVALID_ARG     = 3,
    RESAMPLER_ERR_PTR_OVERLAP     = 4,
+   RESAMPLER_ERR_OVERFLOW        = 5,
    
    RESAMPLER_ERR_MAX_ERROR
@@ -303,10 +306,10 @@
                                       spx_uint32_t *stride);
 
-/** Get the latency in input samples introduced by the resampler.
+/** Get the latency introduced by the resampler measured in input samples.
  * @param st Resampler state
  */
 int speex_resampler_get_input_latency(SpeexResamplerState *st);
 
-/** Get the latency in output samples introduced by the resampler.
+/** Get the latency introduced by the resampler measured in output samples.
  * @param st Resampler state
  */
Index: /pjproject/trunk/third_party/speex/include/speex/speexdsp_types.h
===================================================================
--- /pjproject/trunk/third_party/speex/include/speex/speexdsp_types.h	(revision 6129)
+++ /pjproject/trunk/third_party/speex/include/speex/speexdsp_types.h	(revision 6129)
@@ -0,0 +1,126 @@
+/* speexdsp_types.h taken from libogg */
+/********************************************************************
+ *                                                                  *
+ * THIS FILE IS PART OF THE OggVorbis SOFTWARE CODEC SOURCE CODE.   *
+ * USE, DISTRIBUTION AND REPRODUCTION OF THIS LIBRARY SOURCE IS     *
+ * GOVERNED BY A BSD-STYLE SOURCE LICENSE INCLUDED WITH THIS SOURCE *
+ * IN 'COPYING'. PLEASE READ THESE TERMS BEFORE DISTRIBUTING.       *
+ *                                                                  *
+ * THE OggVorbis SOURCE CODE IS (C) COPYRIGHT 1994-2002             *
+ * by the Xiph.Org Foundation http://www.xiph.org/                  *
+ *                                                                  *
+ ********************************************************************
+
+ function: #ifdef jail to whip a few platforms into the UNIX ideal.
+ last mod: $Id$
+
+ ********************************************************************/
+/**
+   @file speexdsp_types.h
+   @brief Speex types
+*/
+#ifndef _SPEEX_TYPES_H
+#define _SPEEX_TYPES_H
+
+#if defined(_WIN32)
+
+#  if defined(__CYGWIN__)
+#    include <_G_config.h>
+     typedef _G_int32_t spx_int32_t;
+     typedef _G_uint32_t spx_uint32_t;
+     typedef _G_int16_t spx_int16_t;
+     typedef _G_uint16_t spx_uint16_t;
+#  elif defined(__MINGW32__)
+     typedef short spx_int16_t;
+     typedef unsigned short spx_uint16_t;
+     typedef int spx_int32_t;
+     typedef unsigned int spx_uint32_t;
+#  elif defined(__MWERKS__)
+     typedef int spx_int32_t;
+     typedef unsigned int spx_uint32_t;
+     typedef short spx_int16_t;
+     typedef unsigned short spx_uint16_t;
+#  else
+     /* MSVC/Borland */
+     typedef __int32 spx_int32_t;
+     typedef unsigned __int32 spx_uint32_t;
+     typedef __int16 spx_int16_t;
+     typedef unsigned __int16 spx_uint16_t;
+#  endif
+
+#elif defined(__MACOS__)
+
+#  include <sys/types.h>
+   typedef SInt16 spx_int16_t;
+   typedef UInt16 spx_uint16_t;
+   typedef SInt32 spx_int32_t;
+   typedef UInt32 spx_uint32_t;
+
+#elif (defined(__APPLE__) && defined(__MACH__)) /* MacOS X Framework build */
+
+#  include <sys/types.h>
+   typedef int16_t spx_int16_t;
+   typedef u_int16_t spx_uint16_t;
+   typedef int32_t spx_int32_t;
+   typedef u_int32_t spx_uint32_t;
+
+#elif defined(__BEOS__)
+
+   /* Be */
+#  include <inttypes.h>
+   typedef int16_t spx_int16_t;
+   typedef u_int16_t spx_uint16_t;
+   typedef int32_t spx_int32_t;
+   typedef u_int32_t spx_uint32_t;
+
+#elif defined (__EMX__)
+
+   /* OS/2 GCC */
+   typedef short spx_int16_t;
+   typedef unsigned short spx_uint16_t;
+   typedef int spx_int32_t;
+   typedef unsigned int spx_uint32_t;
+
+#elif defined (DJGPP)
+
+   /* DJGPP */
+   typedef short spx_int16_t;
+   typedef int spx_int32_t;
+   typedef unsigned int spx_uint32_t;
+
+#elif defined(R5900)
+
+   /* PS2 EE */
+   typedef int spx_int32_t;
+   typedef unsigned spx_uint32_t;
+   typedef short spx_int16_t;
+
+#elif defined(__SYMBIAN32__)
+
+   /* Symbian GCC */
+   typedef signed short spx_int16_t;
+   typedef unsigned short spx_uint16_t;
+   typedef signed int spx_int32_t;
+   typedef unsigned int spx_uint32_t;
+
+#elif defined(CONFIG_TI_C54X) || defined (CONFIG_TI_C55X)
+
+   typedef short spx_int16_t;
+   typedef unsigned short spx_uint16_t;
+   typedef long spx_int32_t;
+   typedef unsigned long spx_uint32_t;
+
+#elif defined(CONFIG_TI_C6X)
+
+   typedef short spx_int16_t;
+   typedef unsigned short spx_uint16_t;
+   typedef int spx_int32_t;
+   typedef unsigned int spx_uint32_t;
+
+#else
+
+#include "speexdsp_config_types.h"
+
+#endif
+
+#endif  /* _SPEEX_TYPES_H */
Index: /pjproject/trunk/third_party/speex/libspeex/arch.h
===================================================================
--- /pjproject/trunk/third_party/speex/libspeex/arch.h	(revision 6128)
+++ /pjproject/trunk/third_party/speex/libspeex/arch.h	(revision 6129)
@@ -8,16 +8,16 @@
    modification, are permitted provided that the following conditions
    are met:
-   
+
    - Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
-   
+
    - Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
-   
+
    - Neither the name of the Xiph.org Foundation nor the names of its
    contributors may be used to endorse or promote products derived from
    this software without specific prior written permission.
-   
+
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
@@ -50,5 +50,5 @@
 #error You cannot compile as floating point and fixed point at the same time
 #endif
-#ifdef _USE_SSE
+#ifdef USE_SSE
 #error SSE is only for floating-point
 #endif
@@ -76,5 +76,5 @@
 
 #ifndef OUTSIDE_SPEEX
-#include "speex/speex_types.h"
+#include "speex/speexdsp_types.h"
 #endif
 
@@ -90,5 +90,5 @@
 
 typedef spx_int16_t spx_word16_t;
-typedef spx_int32_t   spx_word32_t;
+typedef spx_int32_t spx_word32_t;
 typedef spx_word32_t spx_mem_t;
 typedef spx_word16_t spx_coef_t;
@@ -109,4 +109,6 @@
 #define SIG_SHIFT    14
 #define GAIN_SHIFT   6
+
+#define WORD2INT(x) ((x) < -32767 ? -32768 : ((x) > 32766 ? 32767 : (x)))
 
 #define VERY_SMALL 0
@@ -172,4 +174,5 @@
 #define SATURATE16(x,a) (x)
 #define SATURATE32(x,a) (x)
+#define SATURATE32PSHR(x,shift,a) (x)
 
 #define PSHR(a,shift)       (a)
@@ -211,5 +214,6 @@
 #define PDIV32(a,b)     (((spx_word32_t)(a))/(spx_word32_t)(b))
 
-
+#define WORD2INT(x) ((x) < -32767.5f ? -32768 : \
+                    ((x) > 32766.5f ? 32767 : (spx_int16_t)floor(.5 + (x))))
 #endif
 
@@ -218,9 +222,9 @@
 
 /* 2 on TI C5x DSP */
-#define BYTES_PER_CHAR 2 
+#define BYTES_PER_CHAR 2
 #define BITS_PER_CHAR 16
 #define LOG2_BITS_PER_CHAR 4
 
-#else 
+#else
 
 #define BYTES_PER_CHAR 1
Index: /pjproject/trunk/third_party/speex/libspeex/bfin.h
===================================================================
--- /pjproject/trunk/third_party/speex/libspeex/bfin.h	(revision 6129)
+++ /pjproject/trunk/third_party/speex/libspeex/bfin.h	(revision 6129)
@@ -0,0 +1,15 @@
+/* Common Blackfin assembly defines
+ *
+ * Copyright (C) 2005-2009 Analog Devices
+ */
+
+#if __GNUC__ <= 3
+/* GCC-3.4 and older did not use hardware loops and thus did not have
+ * register constraints for declaring clobbers.
+ */
+# define BFIN_HWLOOP0_REGS
+# define BFIN_HWLOOP1_REGS
+#else
+# define BFIN_HWLOOP0_REGS , "LB0", "LT0", "LC0"
+# define BFIN_HWLOOP1_REGS , "LB1", "LT1", "LC1"
+#endif
Index: /pjproject/trunk/third_party/speex/libspeex/buffer.c
===================================================================
--- /pjproject/trunk/third_party/speex/libspeex/buffer.c	(revision 6128)
+++ /pjproject/trunk/third_party/speex/libspeex/buffer.c	(revision 6129)
@@ -1,4 +1,4 @@
 /* Copyright (C) 2007 Jean-Marc Valin
-      
+
    File: buffer.c
    This is a very simple ring buffer implementation. It is not thread-safe
@@ -39,5 +39,5 @@
 #include "os_support.h"
 #include "arch.h"
-#include <speex/speex_buffer.h>
+#include "speex/speex_buffer.h"
 
 struct SpeexBuffer_ {
@@ -100,5 +100,5 @@
 EXPORT int speex_buffer_writezeros(SpeexBuffer *st, int len)
 {
-   /* This is almost the same as for speex_buffer_write() but using 
+   /* This is almost the same as for speex_buffer_write() but using
    SPEEX_MEMSET() instead of SPEEX_COPY(). Update accordingly. */
    int end;
@@ -136,5 +136,5 @@
    if (len > st->available)
    {
-      SPEEX_MEMSET(data+st->available, 0, st->size-st->available);
+      SPEEX_MEMSET(data+st->available, 0, len - st->available);
       len = st->available;
    }
Index: /pjproject/trunk/third_party/speex/libspeex/fftwrap.c
===================================================================
--- /pjproject/trunk/third_party/speex/libspeex/fftwrap.c	(revision 6128)
+++ /pjproject/trunk/third_party/speex/libspeex/fftwrap.c	(revision 6129)
@@ -1,22 +1,22 @@
-/* Copyright (C) 2005-2006 Jean-Marc Valin 
+/* Copyright (C) 2005-2006 Jean-Marc Valin
    File: fftwrap.c
 
-   Wrapper for various FFTs 
+   Wrapper for various FFTs
 
    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:
-   
+
    - Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
-   
+
    - Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
-   
+
    - Neither the name of the Xiph.org Foundation nor the names of its
    contributors may be used to endorse or promote products derived from
    this software without specific prior written permission.
-   
+
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
@@ -63,5 +63,5 @@
    {
       out[i] = SHL16(in[i], shift);
-   }   
+   }
    return shift;
 }
@@ -166,4 +166,55 @@
 }
 
+#elif defined(USE_INTEL_IPP)
+
+#include <ipps.h>
+
+struct ipp_fft_config
+{
+  IppsDFTSpec_R_32f *dftSpec;
+  Ipp8u *buffer;
+};
+
+void *spx_fft_init(int size)
+{
+  int bufferSize = 0;
+  int hint;
+  struct ipp_fft_config *table;
+
+  table = (struct ipp_fft_config *)speex_alloc(sizeof(struct ipp_fft_config));
+
+  /* there appears to be no performance difference between ippAlgHintFast and
+     ippAlgHintAccurate when using the with the floating point version
+     of the fft. */
+  hint = ippAlgHintAccurate;
+
+  ippsDFTInitAlloc_R_32f(&table->dftSpec, size, IPP_FFT_DIV_FWD_BY_N, hint);
+
+  ippsDFTGetBufSize_R_32f(table->dftSpec, &bufferSize);
+  table->buffer = ippsMalloc_8u(bufferSize);
+
+  return table;
+}
+
+void spx_fft_destroy(void *table)
+{
+  struct ipp_fft_config *t = (struct ipp_fft_config *)table;
+  ippsFree(t->buffer);
+  ippsDFTFree_R_32f(t->dftSpec);
+  speex_free(t);
+}
+
+void spx_fft(void *table, spx_word16_t *in, spx_word16_t *out)
+{
+  struct ipp_fft_config *t = (struct ipp_fft_config *)table;
+  ippsDFTFwd_RToPack_32f(in, out, t->dftSpec, t->buffer);
+}
+
+void spx_ifft(void *table, spx_word16_t *in, spx_word16_t *out)
+{
+  struct ipp_fft_config *t = (struct ipp_fft_config *)table;
+  ippsDFTInv_PackToR_32f(in, out, t->dftSpec, t->buffer);
+}
+
 #elif defined(USE_GPL_FFTW3)
 
@@ -220,5 +271,5 @@
 }
 
-void spx_ifft(void *table, spx_word16_t *in, spx_word16_t *out) 
+void spx_ifft(void *table, spx_word16_t *in, spx_word16_t *out)
 {
   int i;
@@ -235,5 +286,5 @@
 
   fftwf_execute(t->ifft);
-  
+
   for(i=0;i<N;++i)
     out[i] = optr[i];
Index: /pjproject/trunk/third_party/speex/libspeex/fixed_bfin.h
===================================================================
--- /pjproject/trunk/third_party/speex/libspeex/fixed_bfin.h	(revision 6128)
+++ /pjproject/trunk/third_party/speex/libspeex/fixed_bfin.h	(revision 6129)
@@ -9,16 +9,16 @@
    modification, are permitted provided that the following conditions
    are met:
-   
+
    - Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
-   
+
    - Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
-   
+
    - Neither the name of the Xiph.org Foundation nor the names of its
    contributors may be used to endorse or promote products derived from
    this software without specific prior written permission.
-   
+
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
@@ -36,4 +36,6 @@
 #ifndef FIXED_BFIN_H
 #define FIXED_BFIN_H
+
+#include "bfin.h"
 
 #undef PDIV32_16
@@ -58,5 +60,5 @@
    : "=m" (res)
    : "m" (a), "m" (bb)
-   : "P0", "R0", "R1", "cc");
+   : "P0", "R0", "R1", "ASTAT" BFIN_HWLOOP0_REGS);
    return res;
 }
@@ -67,7 +69,7 @@
    spx_word32_t res, bb;
    bb = b;
-   /* Make the roundinf consistent with the C version 
+   /* Make the roundinf consistent with the C version
       (do we need to do that?)*/
-   if (a<0) 
+   if (a<0)
       a += (b-1);
    __asm__  (
@@ -85,5 +87,5 @@
    : "=m" (res)
    : "m" (a), "m" (bb)
-   : "P0", "R0", "R1", "cc");
+   : "P0", "R0", "R1", "ASTAT" BFIN_HWLOOP0_REGS);
    return res;
 }
@@ -99,4 +101,5 @@
    : "=d" (res)
    : "%d" (a), "d" (b)
+   : "ASTAT"
    );
    return res;
@@ -114,5 +117,5 @@
    : "=&W" (res), "=&d" (b)
    : "d" (a), "1" (b)
-   : "A1"
+   : "A1", "ASTAT"
    );
    return res;
@@ -131,5 +134,5 @@
    : "=&W" (res), "=&d" (b)
    : "d" (a), "1" (b), "d" (c)
-   : "A1"
+   : "A1", "ASTAT"
          );
    return res;
@@ -148,5 +151,5 @@
    : "=W" (res), "=d" (a), "=d" (b)
    : "1" (a), "2" (b)
-   : "A1"
+   : "A1", "ASTAT"
          );
    return res;
@@ -166,5 +169,5 @@
    : "=&W" (res), "=&d" (b)
    : "d" (a), "1" (b), "d" (c)
-   : "A1"
+   : "A1", "ASTAT"
          );
    return res;
Index: /pjproject/trunk/third_party/speex/libspeex/fixed_generic.h
===================================================================
--- /pjproject/trunk/third_party/speex/libspeex/fixed_generic.h	(revision 6128)
+++ /pjproject/trunk/third_party/speex/libspeex/fixed_generic.h	(revision 6129)
@@ -8,16 +8,16 @@
    modification, are permitted provided that the following conditions
    are met:
-   
+
    - Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
-   
+
    - Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
-   
+
    - Neither the name of the Xiph.org Foundation nor the names of its
    contributors may be used to endorse or promote products derived from
    this software without specific prior written permission.
-   
+
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
@@ -52,4 +52,8 @@
 #define SATURATE16(x,a) (((x)>(a) ? (a) : (x)<-(a) ? -(a) : (x)))
 #define SATURATE32(x,a) (((x)>(a) ? (a) : (x)<-(a) ? -(a) : (x)))
+
+#define SATURATE32PSHR(x,shift,a) (((x)>=(SHL32(a,shift))) ? (a) : \
+                                   (x)<=-(SHL32(a,shift)) ? -(a) : \
+                                   (PSHR32(x, shift)))
 
 #define SHR(a,shift) ((a) >> (shift))
Index: /pjproject/trunk/third_party/speex/libspeex/jitter.c
===================================================================
--- /pjproject/trunk/third_party/speex/libspeex/jitter.c	(revision 6128)
+++ /pjproject/trunk/third_party/speex/libspeex/jitter.c	(revision 6129)
@@ -56,6 +56,4 @@
 
 #include "arch.h"
-#include <speex/speex.h>
-#include <speex/speex_bits.h>
 #include <speex/speex_jitter.h>
 #include "os_support.h"
@@ -467,5 +465,4 @@
    int i;
    unsigned int j;
-   int incomplete = 0;
    spx_int16_t opt;
    
@@ -572,5 +569,4 @@
       {
          i=besti;
-         incomplete = 1;
          /*fprintf (stderr, "incomplete: %d %d %d %d\n", jitter->packets[i].timestamp, jitter->pointer_timestamp, chunk_size, jitter->packets[i].span);*/
       }
